## kamailio 4.3.4

=== doc/cfg_list/Makefile ===

COREPATH=../..

#include $(COREPATH)/Makefile.defs

CFG2TXT=../scripts/cdefs2doc/dump_cfg_defs.pl
CFG2DOCBOOK=../scripts/cdefs2doc/dump_cfg_defs.pl

# output directory for generated txt files
txt_output_dir=.
# output directory for generated docbook xml files
docbook_output_dir=docbook

# list of files containing cfg defs in the following format:
# <filename>:<cfg_grp_name> 
# can be easily updated by adding the output of:
#   make diff-list   (which obeys grp_exclude and file_exclude)
# or completely regenerated by replacing files_list with the output of:
#   make gen-files-list
files_list= \
	$(COREPATH)/cfg_core.c:core \
	$(COREPATH)/sctp_options.c:sctp \
	$(COREPATH)/tcp_options.c:tcp \
	$(COREPATH)/modules/tm/config.c:tm \
	$(COREPATH)/modules/registrar/config.c:registrar \
	$(COREPATH)/modules/siputils/config.c:siputils \
	$(COREPATH)/modules/maxfwd/maxfwd.c:maxfwd \
	$(COREPATH)/modules/carrierroute/config.c:carrierroute \
	$(COREPATH)/modules/malloc_test/malloc_test.c:malloc_test \
	$(COREPATH)/modules/tls/tls_cfg.c:tls \
	$(COREPATH)/modules/dispatcher/config.c:dispatcher \
	$(COREPATH)/modules/websocket/config.c:websocket \
	$(COREPATH)/modules/outbound/config.c:outbound \
	$(COREPATH)/modules/stun/config.c:stun


# list of excluded groups
grp_exclude=pa
# list of file prefixes to exclude (full path needed)
file_exclude= $(COREPATH)/modules/tls/

# special per file group overrides
# format= grp_filename=... ,where filename does not contain the extension
# e.g.:
#     grp_f_tcp_options=tcp
#     grp_f_sctp_options=sctp

# special per group group name overrides
# e.g.:
#      grp_g_maxfwd=mf

# override auto-detected group if set to 1 (else the group is used inside the
# file only if it cannot be aut-odetected)
ifeq ($(group_override),1)
override force_grp=force-
else
override force_grp=
endif

# command used for gcc (contains extra includes)
gcc=gcc
#-I$(COREPATH)/lib -I$(COREPATH) -I/usr/include/libxml2

# defines used by gcc
c_defs=-D__CPU_i386 -D__OS_linux -DSER_VER=2099099 -DPKG_MALLOC -DSHM_MEM  \
		-DSHM_MMAP -DDNS_IP_HACK -DUSE_MCAST -DUSE_TCP \
		-DUSE_DNS_CACHE -DUSE_DNS_FAILOVER -DUSE_DST_BLACKLIST -DUSE_NAPTR \
		-DUSE_TLS -DTLS_HOOKS -DFAST_LOCK   -DCC_GCC_LIKE_ASM \
		-DHAVE_GETHOSTBYNAME2 -DHAVE_UNION_SEMUN -DHAVE_SCHED_YIELD \
		-DHAVE_MSG_NOSIGNAL -DHAVE_MSGHDR_MSG_CONTROL -DHAVE_ALLOCA_H \
		-DHAVE_SCHED_SETSCHEDULER -DHAVE_EPOLL -DUSE_SCTP -DNAME='\"ser\"' \
		-DVERSION='\"2.99.99-pre3\"' -DARCH='\"i386\"' -DOS_QUOTED='\"linux\"'


# common makefile vars used in defs
LOCALBASE=/usr/local
SYSBASE=/usr

filter_files=$(filter-out $(addsuffix %,$(file_exclude)),\
				$(filter-out $(addprefix %:,$(grp_exclude)),$(1)))

#filtered files list
flist=$(call filter_files,$(files_list))

# throws an error if input is not in the format filename:grp
check_fname_grp=$(if $(filter-out 2,$(words $(subst :, ,$(1)))),\
					$(error bad format "$(1)", it should be filename:grp))

# get prereq from file:grp (get_prereq(file:grp) => file)
get_prereq=$(firstword $(subst :, ,$(1)))

# get grp from file:grp (get_grp(file:grp) => grp)
get_listed_grp=$(word 2, $(subst :, ,$(1)))

# get base file name from file:grp: get_bname(file:grp) 
# => basename(file) without extension (e.g. get_bname(foo/bar.c:x) => bar)
# 
get_bname=$(basename $(notdir $(call get_prereq,$(1))))

#get grp from file:grp, using the overrides
get_grp=$(strip $(if $(grp_f_$(call get_bname,$(1))), \
					$(grp_f_$(call get_bname,$(1))),\
					$(if $(grp_g_$(call get_listed_grp,$(1))),\
						$(grp_g_$(call get_listed_grp,$(1))),\
						$(call get_listed_grp,$(1))) ) )

# get target from file:grp (get_target(file:grp) => cfg_grp.txt)
get_target=cfg_$(call get_grp,$(1))


# $(LF) definition (do not remove)
define LF


endef

# get all the lines containing DEFS or INCLUDES definitions from the Makefile.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_idefs=$(subst ^LF^,$(LF),$(shell sed \
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*[^\]$$/H'\
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/H'\
 -ne '$${g;s/\n/^LF^/g;p}'\
< $(1)/Makefile ))


# get all the lines from the makefile containing variable definitions.
# It will also return conditionals and try to filter out possible rules.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_vars=$(subst ^LF^,$(LF),$(shell sed -n \
 -e ': start' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]*\($$\|.*[^\]$$\)/{H;b end}' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]\+.*[\]$$/,/[^\]$$/{H;b end}' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*[^\]$$/{H;b end}' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/{H;b end}' \
 -e ': end' \
 -e '$${g;s/\n/^LF^/g;p}'\
 -e 'b' \
 -e ': eat_rule' \
 -e '$$b end' \
 -e 'n' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t]/b eat_rule' \
 -e 'b start' \
< $(1)/Makefile ))


define  mk_rules

$(call check_fname_grp, $(1))

#$$(info generating cfg_$$(call get_grp,$(1)).txt: $$(call get_prereq,$(1)))


DEFS:=
INCLUDES:=
# extract all the includes and defs from the module makefile and
# evaluate them
$$(eval $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
# override COREPATH (we know better)
COREPATH=../..
# save the result in a per group e_idefs_<grp_name> var
$$(eval e_idefs_$$(call get_grp,$(1)):=$$(DEFS) $$(INCLUDES))

# debugging:
#$$(info eval: $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
#$$(info e_idefs_$$(call get_grp,$(1))=$$(e_idefs_$$(call get_grp,$(1))))

$(txt_output_dir)/$$(call get_target,$(1)).txt: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2TXT) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --txt \
		--defs="$(c_defs) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)

$(docbook_output_dir)/$$(call get_target,$(1)).xml: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2DOCBOOK) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --docbook \
		--defs="$(c_defs) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)


clean_$$(call get_target,$(1)).txt:
	rm -f "$(txt_output_dir)/$$(call get_target,$(1)).txt"

clean_$$(call get_target,$(1)).xml:
	rm -f "$(docbook_output_dir)/$$(call get_target,$(1)).xml"

txt: $(txt_output_dir)/$$(call get_target,$(1)).txt

docbook: $(docbook_output_dir)/$$(call get_target,$(1)).xml

clean_txt: clean_$$(call get_target,$(1)).txt

clean_docbook: clean_$$(call get_target,$(1)).xml


endef

find_cfg_files_cmd= find $(COREPATH) -type f -name "*.c" \
		-exec grep "cfg_def_t[	 ][a-zA-Z0-9_]*\[\][	 ]*=" /dev/null {} \; \
		| cut -d: -f1

# shell command to generate a file:grp list from a list of files
# grp will be the modulename if the file is in a module directory or
# the file name with the extension and _cfg, cfg_ or _options stripped out of
# it.
# output: list of  " "filename":"grpname
gen_file_grp_cmd=\
sed -e "s!\(.*/modules[^/]*/\([^/][^/]*\)/.*\)! \1:\2!" \
    -e "s!^\([^ ].*/\([^/.]*\)[^/]*$$\)!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_cfg[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)cfg[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_options[_]*!\1:\2!"

# special vars for generating the list of files or updates
found_lst=$(shell $(find_cfg_files_cmd) | $(gen_file_grp_cmd))
# filtered found lst
f_found_lst=$(call filter_files,$(found_lst))
diff_lst=$(filter-out $(flist),$(f_found_lst))


get_core_files=$(filter-out $(COREPATH)/modules% $(COREPATH)/lib%,$(1))
sort_files=$(sort $(call get_core_files,$(1)))\
			$(sort $(filter-out $(call get_core_files,$(1)),$(1)))

# replace $(COREPATH) with the text "$(COREPATH)"
subst_corepath=$(patsubst $(patsubst %/,%,$(COREPATH))/%,\$$(COREPATH)/%,$(1))


# help will be the default rule (on-purpose since without having a patched
# GCC:TranslationUnit module, make all won't work)
.PHONY: help
help:
	@echo "To regenerate $(foreach f,$(flist),$(call get_target,$f).{txt,xml})"
	@echo "type: $(MAKE) all ."
	@echo "or to regenerate all the cfg documentation by searching all"
	@echo " the source files for definitions, type: $(MAKE) autogen ."
	@echo "NOTE: you need the GCC:TranslationUnit perl module with an "
	@echo "extra patch applied (see $(CFG2TXT) --patch)."

.PHONY: txt
txt:

.PHONY: docbook
docbook:

.PHONY: clean_txt
clean_txt:

.PHONY: clean_docbook
clean_docbook:


.PHONY: all
all: txt $(docbook_output_dir)/cfg_var_list.xml

.PHONY: clean
clean: clean_txt clean_docbook
	@rm -f $(docbook_output_dir)/cfg_var_list.xml

.PHONY: proper
proper:
	@rm -f $(txt_output_dir)/cfg_*.txt
	@rm -f $(docbook_output_dir)/cfg_*.xml

repo_ver="sip-router"\
	"git-$(shell  git rev-parse --verify --short=6 HEAD 2>/dev/null)"
ifeq ($(repo_ver),git-)
repo_ver="sip-router unknown"
endif

$(docbook_output_dir)/cfg_var_list.xml: Makefile \
		$(foreach f,$(flist),$(docbook_output_dir)/$(call get_target,$f).xml)
	@echo '<?xml version="1.0" encoding="UTF-8"?>' >$@
	@echo '<!-- this file is autogenerated, do not edit! -->' >>$@
	@echo '<!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.2//EN"' >>$@
	@echo '	"http://www.oasis-open.org/docbook/xml/4.2/docbookx.dtd"' >>$@
	@echo '	[ <!ENTITY % local.common.attrib' >>$@
	@echo "	 \"xmlns:xi CDATA #FIXED 'http://www.w3.org/2001/XInclude'\">]">>$@
	@echo '>' >>$@
	@echo '<book id="cfg_var_list"'\
		'xmlns:xi="http://www.w3.org/2001/XInclude">' >>$@
	@echo '	<title>Runtime Configuration Variables List</title>' >>$@
	@echo '	<bookinfo><revhistory><revision>' >>$@
	@echo '		<revnumber>'$(repo_ver)'</revnumber>' >>$@
	@echo '		<date>'`date -R`'</date>' >>$@
	@echo '		<revremark>' >>$@
	@echo "			Automatically generated by:">>$@
	@echo "			$(MAKE) -C doc/cfg_list $(MAKECMDGOALS)" >>$@
	@echo '		</revremark>' >>$@
	@echo '	</revision></revhistory></bookinfo>' >>$@
	@$(foreach f,$(flist),\
		echo '		<xi:include'\
			'href="'$(call get_target,$f).xml'"/>' \
			>>$@ ; )
	@echo '</book>' >>$@

# finds all the files containing cfg defs
.PHONY: find
find:
	@$(find_cfg_files_cmd)

# print the list of the autogenerated files
.PHONY: print-lst
print-lst:
	@$(find_cfg_files_cmd) | $(gen_file_grp_cmd)

#
.PHONY: gen-file-list
.PHONY: gen-files_list
.PHONY: gen_files_list
gen-file-list gen-files-list gen_files_list:
	@$(foreach f,$(call subst_corepath,$(call sort_files,$(f_found_lst))),\
		echo "$f \\";)

.PHONY: check-list
.PHONY: update-list
.PHONY: diff-list
check-list update-list diff-list:
	@$(foreach f,$(call subst_corepath,$(call sort_files,$(diff_lst))),\
		echo "$f \\";)


# try to generate the docs from all the sources
.PHONY: autogen
autogen:
	@$(MAKE) all files_list="$(call sort_files,$(f_found_lst))"

$(foreach f,$(flist),$(eval $(call mk_rules,$(f))))

=== doc/counter_list/Makefile ===

COREPATH=../..

#include $(COREPATH)/Makefile.defs

CFG2TXT=../scripts/cdefs2doc/dump_counters.pl
CFG2DOCBOOK=../scripts/cdefs2doc/dump_counters.pl

# output directory for generated txt files
txt_output_dir=.
# output directory for generated docbook xml files
docbook_output_dir=docbook

# list of files containing counter defs in the following format:
# <filename>:<cfg_grp_name> 
# can be easily updated by adding the output of:
#   make diff-list   (which obeys grp_exclude and file_exclude)
# or completely regenerated by replacing files_list with the output of:
#   make gen-files-list
files_list= \
	$(COREPATH)/resolve.c:resolve \
	$(COREPATH)/tcp_stats.c:tcp \
	$(COREPATH)/sctp_stats.c:sctp \
	$(COREPATH)/modules/db_mysql/mysql_mod.c:db_mysql



# list of excluded groups
grp_exclude=
# list of file prefixes to exclude (full path needed)
file_exclude=$(COREPATH)/modules_s/tls/ \
				$(COREPATH)/obsolete

# special per file group overrides
# format= grp_filename=... ,where filename does not contain the extension
# e.g.:
#     grp_f_tcp_stats=tcp
#     grp_f_sctp_stats=sctp

# special per group group name overrides
# e.g.:
#      grp_g_maxfwd=mf
grp_g_resolve=dns
grp_g_db_mysql=mysql

# override auto-detected group if set to 1 (else the group is used inside the
# file only if it cannot be autodetected)
ifeq ($(group_override),1)
override force_grp=force-
else
override force_grp=
endif

# command used for gcc (contains extra includes)
gcc=gcc
#-I$(COREPATH)/lib -I$(COREPATH) -I/usr/include/libxml2

# defines used by gcc
c_defs=-D__CPU_i386 -D__OS_linux -DSER_VER=2099099 -DPKG_MALLOC -DSHM_MEM  \
		-DSHM_MMAP -DDNS_IP_HACK -DUSE_MCAST -DUSE_TCP \
		-DUSE_DNS_CACHE -DUSE_DNS_FAILOVER -DUSE_DST_BLACKLIST -DUSE_NAPTR \
		-DUSE_TLS -DTLS_HOOKS -DFAST_LOCK   -DCC_GCC_LIKE_ASM \
		-DHAVE_GETHOSTBYNAME2 -DHAVE_UNION_SEMUN -DHAVE_SCHED_YIELD \
		-DHAVE_MSG_NOSIGNAL -DHAVE_MSGHDR_MSG_CONTROL -DHAVE_ALLOCA_H \
		-DHAVE_SCHED_SETSCHEDULER -DHAVE_EPOLL -DUSE_SCTP -DNAME='\"ser\"' \
		-DVERSION='\"2.99.99-pre3\"' -DARCH='\"i386\"' -DOS_QUOTED='\"linux\"'


# common makefile vars used in defs
LOCALBASE=/usr/local
SYSBASE=/usr

filter_files=$(filter-out $(addsuffix %,$(file_exclude)),\
				$(filter-out $(addprefix %:,$(grp_exclude)),$(1)))

#filtered files list
flist=$(call filter_files,$(files_list))

# throws an error if input is not in the format filename:grp
check_fname_grp=$(if $(filter-out 2,$(words $(subst :, ,$(1)))),\
					$(error bad format "$(1)", it should be filename:grp))

# get prereq from file:grp (get_prereq(file:grp) => file)
get_prereq=$(firstword $(subst :, ,$(1)))

# get grp from file:grp (get_grp(file:grp) => grp)
get_listed_grp=$(word 2, $(subst :, ,$(1)))

# get base file name from file:grp: get_bname(file:grp) 
# => basename(file) without extension (e.g. get_bname(foo/bar.c:x) => bar)
# 
get_bname=$(basename $(notdir $(call get_prereq,$(1))))

#get grp from file:grp, using the overrides
get_grp=$(strip $(if $(grp_f_$(call get_bname,$(1))), \
					$(grp_f_$(call get_bname,$(1))),\
					$(if $(grp_g_$(call get_listed_grp,$(1))),\
						$(grp_g_$(call get_listed_grp,$(1))),\
						$(call get_listed_grp,$(1))) ) )

# get target from file:grp (get_target(file:grp) => counter_grp.txt)
get_target=counters_$(call get_grp,$(1))


# $(LF) definition (do not remove)
define LF


endef

# get all the lines containing DEFS or INCLUDES definitions from the Makefile.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_idefs=$(subst ^LF^,$(LF),$(shell sed \
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*[^\]$$/H'\
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/H'\
 -ne '$${g;s/\n/^LF^/g;p}'\
< $(1)/Makefile ))


# get all the lines from the makefile containing variable definitions.
# It will also return conditionals and try to filter out possible rules.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_vars=$(subst ^LF^,$(LF),$(shell sed -n \
 -e ': start' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]*\($$\|.*[^\]$$\)/{H;b end}' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]\+.*[\]$$/,/[^\]$$/{H;b end}' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*[^\]$$/{H;b end}' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/{H;b end}' \
 -e ': end' \
 -e '$${g;s/\n/^LF^/g;p}'\
 -e 'b' \
 -e ': eat_rule' \
 -e '$$b end' \
 -e 'n' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t]/b eat_rule' \
 -e 'b start' \
< $(1)/Makefile ))


define  mk_rules

$(call check_fname_grp, $(1))

#$$(info generating counter_$$(call get_grp,$(1)).txt: $$(call get_prereq,$(1)))


DEFS:=
INCLUDES:=
# extract all the includes and defs from the module makefile and
# evaluate them
$$(eval $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
# override COREPATH (we know better)
COREPATH=../..
# save the result in a per group e_idefs_<grp_name> var
$$(eval e_idefs_$$(call get_grp,$(1)):=$$(DEFS) $$(INCLUDES))

# debugging:
#$$(info eval: $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
#$$(info e_idefs_$$(call get_grp,$(1))=$$(e_idefs_$$(call get_grp,$(1))))

$(txt_output_dir)/$$(call get_target,$(1)).txt: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2TXT) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --txt \
		--defs="$(c_defs) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)

$(docbook_output_dir)/$$(call get_target,$(1)).xml: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2DOCBOOK) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --docbook \
		--defs="$(c_defs) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)


clean_$$(call get_target,$(1)).txt:
	rm -f "$(txt_output_dir)/$$(call get_target,$(1)).txt"

clean_$$(call get_target,$(1)).xml:
	rm -f "$(docbook_output_dir)/$$(call get_target,$(1)).xml"

txt: $(txt_output_dir)/$$(call get_target,$(1)).txt

docbook: $(docbook_output_dir)/$$(call get_target,$(1)).xml

clean_txt: clean_$$(call get_target,$(1)).txt

clean_docbook: clean_$$(call get_target,$(1)).xml


endef

find_counter_files_cmd= find $(COREPATH) -type f -name "*.c" \
		-exec grep "counter_def_t[	 ][	 ]*[a-zA-Z0-9_][a-zA-Z0-9_]*\[\][	 ]*=" /dev/null {} \; \
		| cut -d: -f1

# shell command to generate a file:grp list from a list of files
# grp will be the modulename if the file is in a module directory or
# the file name with the extension and _cnt, cnt_, _stats, stats_,
# _cnts, or cnts_ stripped out of
# it.
# output: list of  " "filename":"grpname
gen_file_grp_cmd=\
sed -e "s!\(.*/modules[^/]*/\([^/][^/]*\)/.*\)! \1:\2!" \
    -e "s!^\([^ ].*/\([^/.]*\)[^/]*$$\)!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_cnts\?[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)cnts\?[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_stats[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)stats[_]*!\1:\2!"

# special vars for generating the list of files or updates
found_lst=$(shell $(find_counter_files_cmd) | $(gen_file_grp_cmd))
# filtered found lst
f_found_lst=$(call filter_files,$(found_lst))
diff_lst=$(filter-out $(flist),$(f_found_lst))


get_core_files=$(filter-out $(COREPATH)/modules% $(COREPATH)/lib%,$(1))
sort_files=$(sort $(call get_core_files,$(1)))\
			$(sort $(filter-out $(call get_core_files,$(1)),$(1)))

# replace $(COREPATH) with the text "$(COREPATH)"
subst_corepath=$(patsubst $(patsubst %/,%,$(COREPATH))/%,\$$(COREPATH)/%,$(1))


# help will be the default rule (on-purpose since without having a patched
# GCC:TranslationUnit module, make all won't work)
.PHONY: help
help:
	@echo "To regenerate $(foreach f,$(flist),$(call get_target,$f).{txt,xml})"
	@echo "type: $(MAKE) all ."
	@echo "or to regenerate all the counter lists by searching all"
	@echo " the source files for definitions, type: $(MAKE) autogen ."
	@echo "NOTE: you need the GCC:TranslationUnit perl module with an "
	@echo "extra patch applied (see $(CFG2TXT) --patch)."

.PHONY: txt
txt:

.PHONY: docbook
docbook:

.PHONY: clean_txt
clean_txt:

.PHONY: clean_docbook
clean_docbook:


.PHONY: all
all: txt $(docbook_output_dir)/counter_list.xml

.PHONY: clean
clean: clean_txt clean_docbook
	@rm -f $(docbook_output_dir)/counter_list.xml

.PHONY: proper
proper:
	@rm -f $(txt_output_dir)/counters_*.txt
	@rm -f $(docbook_output_dir)/counters_*.xml

repo_ver="sip-router"\
	"git-$(shell  git rev-parse --verify --short=6 HEAD 2>/dev/null)"
ifeq ($(repo_ver),git-)
repo_ver="sip-router unknown"
endif

$(docbook_output_dir)/counter_list.xml: Makefile \
		$(foreach f,$(flist),$(docbook_output_dir)/$(call get_target,$f).xml)
	@echo '<?xml version="1.0" encoding="UTF-8"?>' >$@
	@echo '<!-- this file is autogenerated, do not edit! -->' >>$@
	@echo '<!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.2//EN"' >>$@
	@echo '	"http://www.oasis-open.org/docbook/xml/4.2/docbookx.dtd"' >>$@
	@echo '	[ <!ENTITY % local.common.attrib' >>$@
	@echo "	 \"xmlns:xi CDATA #FIXED 'http://www.w3.org/2001/XInclude'\">]">>$@
	@echo '>' >>$@
	@echo '<book id="counter_list"'\
		'xmlns:xi="http://www.w3.org/2001/XInclude">' >>$@
	@echo '	<title>Counter List</title>' >>$@
	@echo '	<bookinfo><revhistory><revision>' >>$@
	@echo '		<revnumber>'$(repo_ver)'</revnumber>' >>$@
	@echo '		<date>'`date -R`'</date>' >>$@
	@echo '		<revremark>' >>$@
	@echo "			Automatically generated by:">>$@
	@echo "			$(MAKE) -C doc/counter_list $(MAKECMDGOALS)" >>$@
	@echo '		</revremark>' >>$@
	@echo '	</revision></revhistory></bookinfo>' >>$@
	@$(foreach f,$(flist),\
		echo '		<xi:include'\
			'href="'$(call get_target,$f).xml'"/>' \
			>>$@ ; )
	@echo '</book>' >>$@

# finds all the files containing cfg defs
.PHONY: find
find:
	@$(find_counter_files_cmd)

# print the list of the autogenerated files
.PHONY: print-lst
print-lst:
	@$(find_counter_files_cmd) | $(gen_file_grp_cmd)

#
.PHONY: gen-file-list
.PHONY: gen-files_list
.PHONY: gen_files_list
gen-file-list gen-files-list gen_files_list:
	@$(foreach f,$(call subst_corepath,$(call sort_files,$(f_found_lst))),\
		echo "$f \\";)

.PHONY: check-list
.PHONY: update-list
.PHONY: diff-list
check-list update-list diff-list:
	@$(foreach f,$(call subst_corepath,$(call sort_files,$(diff_lst))),\
		echo "$f \\";)


# try to generate the docs from all the sources
.PHONY: autogen
autogen:
	@$(MAKE) all files_list="$(call sort_files,$(f_found_lst))"

$(foreach f,$(flist),$(eval $(call mk_rules,$(f))))

=== lib/ims/Makefile ===

# example library makefile
#

include ../../Makefile.defs
auto_gen=
NAME:=kamailio_ims
MAJOR_VER=0
MINOR_VER=1
BUGFIX_VER=0
DEFS+=-DSER

ifeq ($(CROSS_COMPILE),)
XML2CFG=$(shell which xml2-config)
endif

ifneq ($(XML2CFG),)
	libxml2_includes = $(shell $(XML2CFG) --cflags)
	libxml2_libs = $(shell $(XML2CFG) --libs)
else
	libxml2_includes = -I$(LOCALBASE)/include/libxml2 -I$(LOCALBASE)/include
	libxml2_libs = -L$(LOCALBASE)/lib -lxml2
endif

INCLUDES= -I$(CURDIR)/.. -I$(CURDIR)/../.. $(libxml2_includes) 
LIBS=$(libxml2_libs)
#SERLIBPATH=..
#SER_LIBS=$(SERLIBPATH)/cds/ser_cds

include ../../Makefile.libs

=== lib/kcore/Makefile ===
include ../../Makefile.defs
auto_gen=
NAME:=kcore
MAJOR_VER=1
MINOR_VER=0
BUGFIX_VER=0
LIBS=

SERLIBPATH=..
SER_LIBS=

include ../../Makefile.libs

=== modules/acc/Makefile ===
# acc module makefile
#
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=acc.so
LIBS=

# comment the next line if you wish to disable SQL accounting
DEFS+=-DSQL_ACC

# set ENABLE_RADIUS_ACC to true if you wish to enable RADIUS accounting
#   (uncomment next line or 'ENABLE_RADIUS_ACC=true make all')
#ENABLE_RADIUS_ACC=true
ifeq ($(ENABLE_RADIUS_ACC),true)
include ../../Makefile.radius
DEFS+=-DRAD_ACC
endif

# set ENABLE_DIAMETER_ACC to true if you wish to enable DIAMETER accounting
#   (uncomment next line or 'ENABLE_DIAMETER_ACC=true make all')
#ENABLE_DIAMETER_ACC=true
ifeq ($(ENABLE_DIAMETER_ACC),true)
DEFS+=-DDIAM_ACC
endif

DEFS+=-DKAMAILIO_MOD_INTERFACE

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/srdb1/srdb1 $(SERLIBPATH)/kcore/kcore

include ../../Makefile.modules

=== modules/acc_radius/Makefile ===
# acc_radius module makefile
#
#
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=acc_radius.so
LIBS=

include ../../Makefile.radius

DEFS+=-DKAMAILIO_MOD_INTERFACE

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/kcore/kcore

include ../../Makefile.modules

=== modules/app_java/Makefile ===
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=app_java.so

#DEFS += -DEXTRA_DEBUG

DIST = $(shell if [ -f "/etc/redhat-release" ]; then cat /etc/redhat-release | sed "s/.*\([0-9]\)\.[0-9].*/\1/g"; fi)
ifeq ($(DIST),6)
JVM_PATH = $(shell dirname `find /usr/lib/jvm/java/ -name "libjvm.so"`)
DEFS += $(shell pkg-config libgcj-4.4 --cflags)
LIBS += $(shell pkg-config libgcj-4.4 --cflags) -L$(JVM_PATH) -ljvm
else
# try to detect JAVA_HOME
JAVA_HOME ?= $(shell readlink -f /usr/bin/javac | sed "s:bin/javac::")
DEFS += $(shell pkg-config libgcj --cflags) -I$(JAVA_HOME)/include
LIBS += $(shell pkg-config libgcj --libs) -L$(JAVA_HOME)/lib  -ljvm

# On Debian 7.5 there is a bug with JAVA_HOME detection.
# $(shell readlink -f /usr/bin/javac | sed "s:bin/javac::") points to perl wrapper script (/usr/bin/gcj-wrapper-4.7)
# whereas the real compiler is at /usr/bin/gcj-4.7. As the result, JAVA_HOME will not be a directory, that is incorrect.
# At this point I don't see any universal method as explicit setting this variable at the compile phase.
# -- ez
ifeq ($(shell [ -d "${JAVA_HOME}" -a -f "$(JAVA_HOME)/include/jni.h" -a -f "$(JAVA_HOME)/lib/libjvm.so" ] && echo 1 || echo 0),0)
    $(error Can't locate Java Development Kit. You have to specify environment JAVA_HOME to build app_java)
endif

ifeq ($(OS), freebsd)
LIBS+=-pthread
endif
ifeq ($(OS), linux)
DEFS += -I$(JAVA_HOME)/include/linux
endif
endif

# disable optimisation for segfaults debugging
INCLUDE += -O0 -g
INCLUDES += -O0 -g

DEFS+=-DKAMAILIO_MOD_INTERFACE

include ../../Makefile.modules

=== modules/app_lua/Makefile ===
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=app_lua.so

ifeq ($(CROSS_COMPILE),)
	BUILDER = $(shell which lua-config)
endif

ifeq ($(BUILDER),)
	ifeq ($(CROSS_COMPILE),)
		BUILDER = $(shell which pkg-config)
	endif
	ifeq ($(BUILDER),)
		LUA51 = $(shell ls $(LOCALBASE)/lib/liblua* | grep liblua5.1)
		DEFS+= -I$(LOCALBASE)/include
		LIBS+= -L$(LOCALBASE)/lib -lm
		ifneq ($(LUA51),)
			DEFS+= -I$(LOCALBASE)/include/lua5.1
			LIBS+= -llua5.1
		else
			LUA52 = $(shell ls $(LOCALBASE)/lib/liblua* | grep liblua5.2)
			ifneq ($(LUA52),)
				DEFS+= -DLUA_COMPAT_MODULE -I$(LOCALBASE)/include/lua5.2
				LIBS+= -llua5.2
			else
				DEFS+= -I$(LOCALBASE)/include/lua
				LIBS+= -llua
			endif
		endif
	else
		LUAVER=XX
		LUALIBS = $(shell pkg-config --silence-errors --libs lua-5.1)
		ifeq ($(LUALIBS),)
			LUALIBS = $(shell pkg-config --silence-errors --libs lua5.1)
			ifeq ($(LUALIBS),)
				LUALIBS = $(shell pkg-config --silence-errors --libs lua5.2)
				ifeq ($(LUALIBS),)
					LUALIBS = $(shell pkg-config --silence-errors --libs lua)
					ifneq ($(LUALIBS),)
						LUAVER=5X
					endif
				else
					LUAVER=52
				endif
			else
				LUAVER=51
			endif
		else
			LUAVER=51X
		endif
		ifeq ($(LUAVER),XX)
			LUA51 = $(shell ls /usr/lib/liblua* | grep liblua5.1)
			ifneq ($(LUA51),)
				DEFS+= -I/usr/include/lua5.1
				LIBS = -llua5.1 -lm
			else
				LUA52 = $(shell ls /usr/lib/liblua* | grep liblua5.2)
				ifneq ($(LUA51),)
					DEFS+= -DLUA_COMPAT_MODULE -I/usr/include/lua5.2
					LIBS = -llua5.2 -lm
				else
					DEFS+= -I/usr/include/lua
					LIBS = -llua -lm
				endif
			endif
		else
			ifeq ($(LUAVER),51)
				DEFS+= $(shell pkg-config --cflags lua5.1 | sed -e "s/\\\\/'/" -e "s/\\\\\"/\"'/")
				LIBS = $(shell pkg-config --libs lua5.1)
			else
				ifeq ($(LUAVER),51X)
					DEFS+= $(shell pkg-config --cflags lua-5.1)
					LIBS = $(shell pkg-config --libs lua-5.1)
				else
					ifeq ($(LUAVER),52)
						DEFS+= -DLUA_COMPAT_MODULE $(shell pkg-config --cflags lua5.2)
						LIBS = $(shell pkg-config --libs lua5.2)
					else
						DEFS+= $(shell pkg-config --cflags lua)
						LIBS = $(shell pkg-config --libs lua)
					endif
				endif
			endif
		endif
	endif
else
	DEFS+= $(shell lua-config --include)
	LIBS = $(shell lua-config --libs)
endif

DEFS+=-DKAMAILIO_MOD_INTERFACE

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/kcore/kcore

include ../../Makefile.modules

=== modules/app_mono/Makefile ===
#
#

include ../../Makefile.defs
auto_gen=
NAME=app_mono.so

BUILDER = $(shell which pkg-config)
ifeq ($(BUILDER),)
	DEFS+=-D_REENTRANT -I/usr/include/mono-2.0
	LIBS= -lmono-2.0 -lm -lrt -ldl -lpthread
else
	DEFS+= $(shell pkg-config --cflags mono-2)
	LIBS = $(shell pkg-config --libs mono-2)
endif

DEFS+=-DKAMAILIO_MOD_INTERFACE

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/kcore/kcore

include ../../Makefile.modules

=== modules/auth/Makefile ===
#
# auth example module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=auth.so
LIBS=
# DEFS:
#       -DUSE_NC       - compile with nounce count support
#       -DUSE_OT_NONCE - compile with one-time nonces support
DEFS+=-DUSE_NC -DUSE_OT_NONCE

DEFS+=-DSER_MOD_INTERFACE

include ../../Makefile.modules

=== modules/auth_db/Makefile ===
#
# Digest Authentication - Database support
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=auth_db.so
LIBS=

DEFS+=-DKAMAILIO_MOD_INTERFACE

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/kcore/kcore $(SERLIBPATH)/srdb1/srdb1
include ../../Makefile.modules

=== modules/auth_radius/Makefile ===
#
# Digest Authentication - Radius support
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
include ../../Makefile.radius

auto_gen=
NAME=auth_radius.so

DEFS+=-DKAMAILIO_MOD_INTERFACE

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/kcore/kcore

include ../../Makefile.modules

=== debian/changelog ===
kamailio (4.3.4-1.1ubuntu2) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 12:26:47 +0000

kamailio (4.3.4-1.1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control:
      + Build modules on any platform.
      + Use db-upgrade-util instead of hard coding dbX.Y-util
        dependency.

 -- Artur Rona <ari-tczew@ubuntu.com>  Fri, 25 Dec 2015 21:23:17 +0100

kamailio (4.3.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Refresh list of architectures supported by Mono (Closes: #808481)

 -- Jo Shields <directhex@apebox.org>  Mon, 21 Dec 2015 10:14:23 +0000

kamailio (4.3.4-1) unstable; urgency=medium

  * [3ca01af] Imported Upstream version 4.3.4 ( Closes: #806244 )
  * [9702243] remove applied upstream patches

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Thu, 26 Nov 2015 22:06:45 +0100

kamailio (4.3.3-3) unstable; urgency=medium

  * [c615681] upstream patch for mips FTBFS ( Closes: #804749 )

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Wed, 11 Nov 2015 09:23:50 +0100

kamailio (4.3.3-2) unstable; urgency=medium

  * [dd21fe3] add upstream fixes from 4.3 branch (Closes: #804422 #804276)
  * [592ea26] add systemd .service file and dh-systemd commands
  * [207459f] allow virtual-mysql-client as valid
              Depends for kamailio-mysql-modules

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Tue, 10 Nov 2015 11:44:28 +0100

kamailio (4.3.3-1) unstable; urgency=medium

  * [5dad250] Imported Upstream version 4.3.3
  * [cd88d69] refresh upstream patches since 4.3.3

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Tue, 13 Oct 2015 12:22:53 +0200

=== debian/control ===
Source: kamailio
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Victor Seva <linuxmaniac@torreviejawireless.org>,
           Tzafrir Cohen <tzafrir@debian.org>
Build-Depends: bison,
               debhelper (>= 9),
               dh-systemd (>= 1.5),
               docbook-xml,
               dpkg-dev (>= 1.16.1.1),
               erlang-dev,
               flex,
               gcj-jdk,
               libconfuse-dev,
               libcurl4-openssl-dev,
               libdb-dev (>= 4.6.19),
               libev-dev,
               libevent-dev,
               libexpat1-dev,
               libfreeradius-client-dev,
               libgeoip-dev (>= 1.4.5),
               libhiredis-dev (>= 0.10.0),
               libjansson-dev,
               libjson-c-dev,
               libldap2-dev,
               liblua5.1-0-dev,
               libmemcached-dev,
               libmono-2.0-dev [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x],
               libmysqlclient-dev,
               libncurses5-dev,
               libpcre3-dev,
               libperl-dev,
               libpq-dev,
               libpurple-dev,
               librabbitmq-dev,
               libreadline-dev,
               libsasl2-dev,
               libsctp-dev [linux-any],
               libsnmp-dev,
               libsqlite3-dev,
               libunistring-dev,
               libval-dev,
               libxml2-dev,
               openssl,
               pkg-config,
               python,
               python-dev,
               unixodbc-dev,
               uuid-dev,
               xsltproc,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://www.kamailio.org/
Vcs-git: git://anonscm.debian.org/pkg-voip/kamailio.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-voip/kamailio.git

Package: kamailio
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         python,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: kamailio-berkeley-modules,
          kamailio-carrierroute-modules,
          kamailio-cpl-modules,
          kamailio-ldap-modules,
          kamailio-lua-modules,
          kamailio-mono-modules,
          kamailio-mysql-modules,
          kamailio-perl-modules,
          kamailio-postgres-modules,
          kamailio-presence-modules,
          kamailio-python-modules,
          kamailio-radius-modules,
          kamailio-redis-modules,
          kamailio-snmpstats-modules,
          kamailio-unixodbc-modules,
          kamailio-xml-modules,
          kamailio-xmpp-modules,
          stun-server | turn-server
Provides: sip-router
Description: very fast and configurable SIP proxy
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 C Shell-like scripting language provides full control over the server's
 behaviour. Its modular architecture allows only required functionality to be
 loaded.
 .
 This package contains the main Kamailio binary along with the principal
 modules and support binaries.

Package: kamailio-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: very fast and configurable SIP proxy [debug symbols]
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package contains the debugging symbols for the Kamailio binaries and
 modules. You only need to install it if you need to debug Kamailio.

Package: kamailio-geoip-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the geoip module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the geoip module, an extension allowing to
 use GeoIP API within configuration file.

Package: kamailio-sqlite-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: sqlite3
Description: SQLite database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the SQLite database driver for Kamailio.

Package: kamailio-json-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Json parser and jsonrpc modules for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides json parser for Kamailio's configuration file
 and the JSON-RPC client over netstrings.

Package: kamailio-memcached-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: kamailio-memcached-module
Description: interface to memcached server
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the memcached module, an interface to the memcached
 server, a high-performance, distributed memory object caching system.

Package: kamailio-lua-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the app_lua module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_lua module, an extension allowing to
 execute embedded Lua applications within configuration file.

Package: kamailio-mono-modules
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the app_mono module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_mono module, an extension allowing to
 execute embedded Mono applications within configuration file.

Package: kamailio-python-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         python-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the app_python module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_python module, an extension allowing to
 execute embedded Python applications within configuration file.

Package: kamailio-redis-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Redis database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the Redis NOSQL database driver for Kamailio.

Package: kamailio-mysql-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         mysql-client | virtual-mysql-client,
         ${misc:Depends},
         ${shlibs:Depends}
Description: MySQL database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the MySQL database driver for Kamailio.

Package: kamailio-postgres-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         postgresql-client,
         ${misc:Depends},
         ${shlibs:Depends}
Description: PostgreSQL database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the PostgreSQL database driver for Kamailio.

Package: kamailio-cpl-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: CPL module (CPL interpreter engine) for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a CPL (Call Processing Language) interpreter for
 Kamailio, turning Kamailio into a CPL server (storage and interpreter).

Package: kamailio-radius-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: RADIUS modules for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a set of RADIUS modules for Kamailio, for
 authentication, peering, group membership and messages URIs checking against
 a RADIUS server.

Package: kamailio-unixodbc-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: unixODBC database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the unixODBC database driver for Kamailio.

Package: kamailio-presence-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: SIMPLE presence modules for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides several Kamailio modules for implementing presence
 server and presence user agent for RICH presence, registrar-based presence,
 external triggered presence and XCAP support.

Package: kamailio-perl-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Perl extensions and database driver for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
